function display(A)
%
% Description:
% ------------
%
%    Displays short info on the object.
%

fprintf(['class <a href="matlab: help ' class(A) ';">' class(A) '</a>{\n']);
%fprintf(['class <a href="matlab: a = ' class(A) '; display(a)' ';">' class(A) '</a>{\n']);
fprintf('\n');

C = metaclass(A);

pp = C.Properties;

ff = [];
for i=1:length(pp)
	ff{i} = pp{i}.Name;
end
ll=[];
for i=1:length(ff)
	ll(i) = length(ff{i});
end
W = max(ll);


for i=1:length(pp)
	p = repmat(' ',1,W-length(ff{i}));
	fprintf('\t');
	fprintf(p);
	fprintf(ff{i});
	fprintf(': ');
	
	if(~pp{i}.Dependent)		
		a = eval(['A.' ff{i}]);
		sz = size(a);
		if isnumeric(a) && prod(sz) == 1
			fprintf(num2str(a));
		elseif isa(a,'char')
			fprintf('''%s''',a);
		else
			fprintf('[');

				fprintf('%gx',sz(1:min(numel(sz),10)-1));
				fprintf('%g',sz(min(numel(sz),10)));
				if(numel(sz)>10)
					fprintf('... ');
				else
					fprintf(' ');	
				end
			if isobject(a)
				fprintf(['<a href="matlab: help ' class(a) ';">' class(a) '</a>']);
				%fprintf(['<a href="matlab: a = ' class(a) '; display(a)' ';">' class(a) '</a>']);
			else
				if issparse(a)
					fprintf(' sp_');
				end
				fprintf(class(a));
			end
			fprintf(']');
			 if issparse(a)
				 fprintf(' nnz:%i',nnz(a));
			 end
		end
	else
		fprintf('[dependent]');
	end
	if(~isempty(pp{i}.GetMethod))
		fprintf('\t');
		fprintf(['<a href="matlab: edit ' unix_slashes(func2str(pp{i}.GetMethod)) ';">' '[get]' '</a>']);
	end
	if(~isempty(pp{i}.SetMethod))
		fprintf(' ');
		fprintf(['<a href="matlab: edit ' unix_slashes(func2str(pp{i}.SetMethod)) ';">' '[set]' '</a>']);
	end
	fprintf('\n');
end

%{
if isfield(struct(A),'slots')
	fprintf('\tslots:\n');
	for a_i=1:size(A.slots,1)
		%if(a_i>1)
			%fprintf('\n\t\t');
		%end
		fprintf('\t\t%s\n',A.slots(a_i,:));
	end
end
%}

fprintf('\n');
mm1 = methods(A);
mm = {};k=1;
for i=1:length(mm1)
	name = mm1{i};
	if strcmp(name,'display') || strcmp(name,'subsasgn') || strcmp(name,'subsref')
		continue;
	end
	mm{k} = name;
	k = k+1;
end

m_disp = mm;
for i=1:length(mm)
	if strcmp(mm{i},'operator_func')
		m_disp{i} = 'operator()';
	end
end

for i=1:length(m_disp)
	ll(i) = length(m_disp{i});
end
W = max(ll);
N = length(mm);
rows = ceil(N/4);
columns = ceil((N-1)/rows+1);

% precompute column widths
w = zeros(columns);
for j = 1:rows %% rows methods in a column, j - row
	for i=1:ceil((N-1)/rows+1) %% i - column
		r = (i-1)*rows+j; % method number
		if(r<=N)
			w(i) = max(w(i),length(mm{r}));
		end
	end
end

for j = 1:rows %% rows methods in a column, j - row
	fprintf('\t');
	for i=1:columns %% i - column
		r = (i-1)*rows+j; % method number
		if(r<=N)
			s = m_disp{r};
			p = repmat(' ',1,w(i)-length(s)+1);
			fprintf(['<a href="matlab: help ' class(A) '/' mm{r} ';">' s '</a>' p]);
			fprintf([' <a href="matlab: edit ' class(A) '/' mm{r} ';">[.m]</a>  ']);
		end
	end
	fprintf('\n');
end
fprintf('}\n');
end