function P = extend_map(F,p)
% Get linear extension P=[p] for mapping p
% Input: p: 2 x nV idempotent map
% Output: P nI x nI matrix, where nI - dimension of the relaxed variable = number of all configurations on all hyperedges
%
nV = get_nV(F);
nA = get_nA(F);
H = F.H;
I = H.A;
nI = nnz(I);
I(I>0) = 1:nI;
%I = nnz(H.A);
% what size is P: I x I
P = sparse(nI,nI);
P(1,1) = 1;
% P_a,x_a,x'_a = [p(x'_a)=x_a]
for a = 2:nA
	v = H.get_nodes(a);
	pv = fliplr(p(:,v));
	d = H.d(a);
	for z1=0:2^d-1
		x1 = mdec2bin(z1,d);
		x = mselect(pv,x1+1,1:d);
		z = mbin2dec(x);
		P(I(z+1,a),I(z1+1,a)) = 1;
	end
end

end