function E1 = to_multilinear(E)
% E1 = to_multilinear(E)
% converts E to the equivalent multilinear polynomial
%

% flips variables in mask
nV = get_nV(E);
nA = get_nA(E);
H = E.H;

E1 = hyper_energy1(H);
E1.fA(:) = 0;

% need to expand every posiform in every hyperedge ,e.g, x1(1-x2)(1-x3) = x1 -x1x2 -x1x3 +x1x2x3
for a=1:nA
	d = H.d(a);
	for z =0:2^d-1 % over all configurations
		x = mdec2bin(z,d);
		m = ~x; % zero entries
		d1 = nnz(m);
		for z1 = 0:2^d1-1 % over all variables that are zero
			x1 = mdec2bin(z1,d1); % x1 = 0 -- expand baracket (1-x_j) as 0 and otherwise as -x_j
			sgn = (-1)^sum(x1);
			x(m) = x1;
			% what hyperedge is x now?
			a2 = H.A(mbin2dec(x)+1,a);
			d2 = nnz(x); % what order is it
			E1.fA(2^d2,a2) = E1.fA(2^d2,a2) + sgn*E.fA(z+1,a);
		end
	end
end
end