function [H j] = add_edge(H,e)
%  [H j] = add_edge(H,e)
%  H = add_edge(H,e) adds a hyperedge specified by e to hypergraph H or if such hyperedge already exists just returns its index
%  Input: e - array of vertices of the hyperedge
% Output: H - new hypergraph, j - index of the added edge


%H.nA = H.nA+1;
%H.A(:,H.nA) = 0;

e = col(sort(e));
D = length(e);
% try to find if edge already exists, among edges of the right size
jj = find(H.d==D);
j = find( all(H.A(H.sub(1:2^D,2),jj) == repmat(e+1,1,length(jj)),1));
j = jj(j);

if(isempty(j)) % didn't find	
	% fill in missing subedges
	ii = zeros(2^D,1);
	for z=0:2^D-2 % this is loop over all subsets, but need to check only subsets of size d-1, whatever
		sub_e = e(logical(bitget(z,1:D)));
		[H ii(z+1)] = add_edge(H,sub_e);
	end	
	H.nA = H.nA+1;
	j = H.nA;
	% display adge which is added
	%fprintf('adding edge: (');
	%fprintf('%i,',e);
	%fprintf(')\n');
	ii(2^D) = j; % self
	H.A(1:2^D,j) = ii;
	H.d(j) = D;
end
end