classdef hyper_graph1 < base_class1
	properties
		d = zeros(1,0);
		A = sparse(0,0);
		nA = 0;
		maxd = 0;
		sub = {};
	end
	methods		
		function H = hyper_graph1(varargin)
			% Create a hyper-graph.
			% 	hyper_graph!() -- empty hyper-graph
			%
			% 	hyper_graph!(nV,maxd) -- hyper-graph with nV nodes and no (hyper-)edges
			%
			%
			H.d = zeros(1,0);
			H.A = sparse(0,0);
			H.nA = 0;
			H.maxd = 0;
			H.sub = {};			
			switch nargin
				case 0
				case 2
					nV = varargin{1}; % number of node;
					H.maxd = varargin{2}; % maximum order
					H.d = [0 ones(1,nV)];
					H.nA = nV+1;
					H.A = sparse(2^H.maxd,nV+1);
					H.A(1,:) = 1;
					H.A(2,2:end) = 1+[1:nV];
				otherwise
					error('Unrecognized arguments');
			end
			H.sub = logical(sparse(2^H.maxd,H.maxd+1));
			for z=0:2^H.maxd-1
				x = mdec2bin(z,H.maxd);
				ii = find(x);
				d = length(ii);
				H.sub(z+1,d+1) = 1;
			end
			%H = class(H,'hyper_graph1');
		end
	end
end