if ~exist('ltop','var')
	ltop = 0.6;
end

cfigure(3);clf; hold on;
set(gcf,'Name','Persistency');
n = length(collect);
%V = reshape([collect.methods],[],n)';

% pick up all recorded methods
rlegend = {};
for it = 1:length(collect)
	meth = fieldnames(collect(it).results);
	for m = 1:length(meth)
		rmethod = meth{m};
		if isempty(strmatch(rmethod,rlegend,'exact'))
			rlegend = [rlegend rmethod];
		end
	end
end
%methods = rlegend;

%V = zeros(n,length(collect(1).legend));
%C = zeros(n,length(collect(1).legend));
V = zeros(n,length(rlegend));
C = zeros(n,length(rlegend));

for it = 1:length(collect)
	meth = fieldnames(collect(it).results);
	for m = 1:length(meth)
		method = meth{m};
		V(it,m) = collect(it).results.(method).time;
		C(it,m) = collect(it).results.(method).elim/maxelim*100;
	end
end

mask = repmat(any(isnan(V),2) | any(isnan(C),2),[1 size(V,2)]);
fprintf(' %i/%i valid results\n', nnz(~mask(:,1)),n);
V(mask) = nan;
C(mask) = nan;

m = mmean(V,1);
mc = mmean(C,1);

dmethods = {};
for me = 1:length(rlegend)
	dmethods{me} = strrep(rlegend{me},'_','-');
	fprintf('%s ', dmethods{me});
	if me < length(rlegend)
		fprintf('| ');
	end
end
fprintf('\\\\\n');
for me = 1:length(rlegend)
	fprintf('%5.2fs/%3.2f%% ', m(me),mc(me));
	if me < length(rlegend)
		fprintf('| ');
	end
end
fprintf('\n');

% 95 confidence interval
% 70 confidence interval
% 50 confidence interval (median)
V = C; m = mc;

VS = sort(V,1);
interval = [0.50 0.70 0.95];
%alpha = [0.3 0.7 1.0];
alpha = [1.0 0.7 0.3];
w = 0.4;
for l = length(interval):-1:1
	%t = ceil(n*(1-interval(l)));
	t = ceil(n*interval(l));
	%alpha = %interval(l)+0.05;
	color = [1 1 1]*(1-alpha(l)) + [0 0 0.5]*alpha(l);
	%hbar = bar(VS(t,:)/maxelim*100,'EdgeColor','none','FaceColor',color);
	hbar = bar(1:size(VS,2),VS(t,:),'EdgeColor','none','FaceColor',color,'BarWidth',w);
end
v = m;
for i=1:length(m)
	if ~isnan(v(i));
		plot([i-w/2 i+w/2], [v(i) v(i)],'r-','LineWidth',2);
	end
end
% 	v = max(VS)/maxelim*100;
% 	for i=1:length(m)
% 		plot([i-w/2 i+w/2], [v(i) v(i)],'k:','LineWidth',1);
% 	end
%baseline_handle = get(bar_handle,'BaseLine');
%set(baseline_handle,'LineStyle','--','Color','red');
nm = length(rlegend);
pos = get(gca,'Position');
set(gca,'Position',[pos(1), .2, pos(3) .65])
Xt = 1:nm;
Xl = [0.1 nm+0.9];
set(gca,'XTick',Xt,'XLim',Xl);
ax = axis;
axis(axis);
Yl = ax(3:4);
%set(gca,'XTickLabel',methods);
% Place the text labels

t = text(Xt,Yl(1)*ones(1,length(Xt)),dmethods);
set(t,'HorizontalAlignment','right','VerticalAlignment','top', 'Rotation',45);
% Remove the default labels
h = legend('95%','70%','50%','mean');
rect = [0.16, ltop+0.05, .15, .20];
set(h, 'Position', rect);
set(gca,'XTickLabel','')
ylabel('solution completeness, %');
%ylabel('time, sec');
box off;
drawnow;
