%pth = 'exp-rand-ht/';

ltop = 0.62;
l1 = [0.14 0];
l2 = [0.17 ltop+0.08];
%tt = 'Grid problems 10x10, non-FLP-tight';
tt = '';

ff = dir([pth '/*.mat']);
group = {ff(:).name};

legg = {'degree 3'};

%
%methods = {'HOCR','Fix','GRD-heur','GRD','GRD-gen','L1-FLP'};
methods = {'HOCR','Fix','GRD-heur','GRD','GRD-gen','Swoboda-14','L1-FLP'};
Legent = {'HOCR','Fix et al.','GRD-heur','GRD','GRD-gen','Swoboda et.al','L1-FLP'};
%
%
colors = [
	0 0.5 0.5;
	0 0 0.5;
	0 0.5 0;
	0.5 0.5 0;
	0.5 0 0.5];
%
rmethods = {};
for mth = 1:length(methods)
	method = strrep(methods{mth},'-','_');
	method = strrep(method,'.','_');
	method = strrep(method,' ','_');
	rmethods{mth} = method;
end
%

VV = [];
ng = length(group);
t_lp = [];
t0 = [];
t1 = [];
t2 = [];
mc = [];
NN = [];

w = 0.8/ng*2/3;
sw = 0.8/ng*1/3;

ymax = -inf;
ymin = inf;

for gi = 1:length(group)
	
	fprintf('%s\n',group{gi});
	
	load([pth group{gi}]);
	
	collect = experiment.collect;
	%methods1 = methods;
	
	ptype = experiment.ptype;
	K = experiment.K;
	N = experiment.N;
	NN(gi) = N;
	M = experiment.M;
	nV = experiment.nV;
	maxelim = experiment.maxelim;
	T = experiment.T;
	gen = experiment.gen;
	maxd = experiment.maxd;
	tight = experiment.tight;
	
	%m_sw = strmatch('Swoboda-CPLEX',methods);
	%methods{m_sw} = 'Swoboda';
	
	n = length(collect);
	
	%VV{gi} = reshape([collect.methods],[],n)'/maxelim*100;
	T0 = zeros(n,length(methods));
	T1 = zeros(n,length(methods));
	T2 = zeros(n,length(methods));
	C = zeros(n,length(methods));
	T_LP = zeros(n,length(methods));
	
	for it = 1:length(collect)
		meth = fieldnames(collect(it).results);
		for m = 1:length(meth)
			method = meth{m};
			% check if this result is wanted
			mi = strmatch(method,rmethods,'exact');
			if ~isempty(mi) % yes, we want to include it
				T0(it,mi) = collect(it).results.(method).ilp_time;				
				T1(it,mi) = collect(it).results.(method).time;
				if ~isempty(strfind(method,'L1'))
					%try
						T1(it,mi) = T1(it,mi) + collect(it).results.(method).lp_time;
						T_LP(it,mi) = collect(it).results.(method).lp_time;
					%catch e
						%T1(it,mi) = nan;
					%end
				end
				T2(it,mi) = collect(it).results.(method).ilp_reduced_time;
				C(it,mi) = collect(it).results.(method).elim/maxelim*100;
			end
		end
	end
	
	mask = repmat(any(isnan(T1),2) | any(isnan(C),2),[1 size(T1,2)]);
	fprintf(' %i/%i valid results\n', nnz(~mask(:,1)),n);
	T0(mask) = nan;
	T1(mask) = nan;
	T2(mask) = nan;
	C(mask) = nan;
	
	t_lp(gi,:,1) = mmean(T_LP,1);
	t_lp(gi,:,2) = std(T_LP,0,1);
	t0(gi,:,1) = mmean(T0,[1 2]); % this is ILP time, should be the same during verification of each method
	t0(gi,:,2) = std(T0(:),0,1);
	t1(gi,:,1) = mmean(T1,1);
	t1(gi,:,2) = std(T1,0,1);
	t2(gi,:,1) = mmean(T1+T2,1);
	t2(gi,:,2) = std(T1+T2,0,1);
	mc(gi,:,1) = mmean(C,1);
	mc(gi,:,2) = std(C,0,1);
end

[NN s] = sort(NN,'ascend');
t_lp = t_lp(s,:,:);
t0 = t0(s,:,:);
t1 = t1(s,:,:);
t2 = t2(s,:,:);
mc = mc(s,:,:);

cc = {':og','-dg','--rs','-xr','-.+r','--*b','-dk'};
%tc = {'g','g','k','k','k','b','k'};
%NN = sqrt(NN);

for ff=1:2
	Legend = Legent;
	cfigure(ff);
	clf; hold on;
	
	for m = 1:length(methods)
		method = methods{m};
		if(ff==1)
			%if strcmp(method,'Swoboda-14')
			%	errorbar(NN(1:7).^2,t1(1:7,m,1),t1(1:7,m,2),cc{m},'LineWidth',1);
			%else
			h = errorbar(NN.^2,t1(:,m,1),t1(:,m,2),cc{m},'LineWidth',1);
			%end
			if strcmp(method,'L1-FLP')
				set(h,'LineWidth',2);
			end
		else
			errorbar(NN.^2,t2(:,m,1),t2(:,m,2),cc{m},'LineWidth',1);
		end
		if ~isempty(strfind(method,'L1-FLP'))
			plot(NN.^2,t_lp(:,m,1),':k','LineWidth',2);
			Legend{end+1} = 'FLP';			
		end
	end
	ylim([0 25]);	
	for m = 1:length(methods)
		method = methods{m};
		if(ff==1)
			for i=5:length(NN)
				if strcmp(method,'L1-FLP') || strcmp(method,'GRD') || (strcmp(method,'GRD-gen') && i >5) || (strcmp(method,'GRD-heur') && i >6)
					s = sprintf('%3.0f%%',mc(i,m,1));
					if strcmp(method,'L1-FLP')
					end
					text(NN(i)^2,t1(i,m,1)+0.04*25*(m==7 && i<7),s,'Color','k');
				end
			end
		end
	end

	if(ff==2)
		errorbar(NN.^2,t0(:,1,1),t0(:,1,2),'-*k','LineWidth',2);
		Legend{end+1} = 'CLPEX-ILP';
		tt = 'Time for persistency + reminder';
	else
		tt = 'Time for persistency only';
	end
	
	%ylim([0 ymax]);
	if(length(NN)>1)
		xlim([min(NN.^2) max(NN.^2)]);
	end
	
	%% text labels
	xlabel('Number of variables');
	ylabel('time, sec');
	box off;
	h = legend(Legend);
	set(h,'Location','NorthWest');
	drawnow;
	set(gcf,'Name',tt);
	h = title(tt);
	set(h, 'Position', [4 91]);
	set(h,'FontWeight','bold');
end