pth = 'exp-randt-h/';

pp = 1;

switch pp
	case 1
		out = 'poly_KS3';
		ltop = 0.62;
		l1 = [0.14 ltop];
		l2 = [0.16+0.25 ltop];
		tt = 'Polynomials of 3rd degree';
		group = {'collect_N100_M1_d3_poly_KS_any_T100_N100.mat'
			'collect_N100_M1_d3_poly_KS_FLP-tight_T200_N100.mat'};
		legg = {'T=100','T=200 non-FLP-tight'};
	case 2
		out = 'poly_KS4';
		ltop = 0.62;
		l1 = [0.14 0];
		l2 = [0.23 ltop+0.1];		
		tt = 'Polynomials of 4th degree';
		group = {'collect_N100_M1_d4_poly_KS_any_T30_N100.mat'
			'collect_N100_M1_d4_poly_KS_FLP-tight_T50_N100.mat'};
		legg = {'T=30','T=50 non-FLP-tight'};
	case 3
		out = 'grid-my';
		ltop = 0.62;
		l1 = [0.14 0];
		l2 = [0.17 ltop+0.08];		
		%tt = 'Grid problems 10x10, non-FLP-tight';
		tt = '';
		group = {'collect_N10_M10_d3_grid_FLP-tight_N10.mat'
			'collect_N10_M10_d4_grid_FLP-tight_N10.mat'};
		legg = {'degree 3','degree 4'};
end
%
methods = {'HOCR','Fix','GRD-heur','GRD','GRD-gen','Swoboda-14','L1-FLP'};
Legent = {'HOCR','Fix et al.','GRD-heur','GRD','GRD-gen','Swoboda et al.','L1-FLP'};
%
%
colors = [
	0 0.5 0.5;
	0 0 0.5;
	0 0.5 0;
	0.5 0.5 0;
	0.5 0 0.5];
%
rmethods = {};
for mth = 1:length(methods)
	method = strrep(methods{mth},'-','_');
	method = strrep(method,'.','_');
	method = strrep(method,' ','_');
	rmethods{mth} = method;
end
%
figure(3);
clf; hold on;

VV = [];
ng = length(group);

w = 0.8/ng*2/3;
sw = 0.8/ng*1/3;

ymax = -inf;
ymin = inf;

clist = [];

for gi = 1:length(group)
	
	load([pth group{gi}]);
	
	collect = experiment.collect;
	%methods1 = methods;
	
	ptype = experiment.ptype;
	K = experiment.K;
	N = experiment.N;
	N = experiment.M;
	nV = experiment.nV;
	maxelim = experiment.maxelim;
	T = experiment.T;
	gen = experiment.gen;
	maxd = experiment.maxd;
	tight = experiment.tight;
	
	%m_sw = strmatch('Swoboda-CPLEX',methods);
	%methods{m_sw} = 'Swoboda';
	
	n = length(collect);
	
	%VV{gi} = reshape([collect.methods],[],n)'/maxelim*100;
	V = zeros(n,length(methods));
	C = zeros(n,length(methods));
	
	for it = 1:length(collect)
		meth = fieldnames(collect(it).results);
		for m = 1:length(meth)
			method = meth{m};
			% check if this result is wanted
			mi = strmatch(method,rmethods,'exact');
			if ~isempty(mi) % yes, we want to include it
				V(it,mi) = collect(it).results.(method).time;
				C(it,mi) = collect(it).results.(method).elim/maxelim*100;
			end
		end
	end
	
	mask = repmat(any(isnan(V),2) | any(isnan(C),2),[1 size(V,2)]);
	fprintf(' %i/%i valid results\n', nnz(~mask(:,1)),n);
	V(mask) = nan;
	C(mask) = nan;
	m = mmean(V,1);
	mc = mmean(C,1);
	% 95 confidence interval
	% 70 confidence interval
	% 50 confidence interval (median)
	%mt = m;
	display(m);
	V = C; m = mc;
	%V = log10(V)+4; m = log10(m)+4;
	
	VS = sort(V,1);
	interval = [0.50 0.70 0.95];
	%alpha = [0.3 0.7 1.0];
	alpha = [1.0 0.7 0.3];
	shift = (gi-1-1/ng/2)*(w+sw)-0.1;
	for l = length(interval):-1:1
		%t = ceil(n*(1-interval(l)));
		t = ceil(n*interval(l));
		%alpha = %interval(l)+0.05;
		%color = [1 1 1]*(1-alpha(l)) + [0 0 0.5]*alpha(l);
		color = [1 1 1]*(1-alpha(l)) + colors(gi,:)*alpha(l);
		%hbar = bar(VS(t,:)/maxelim*100,'EdgeColor','none','FaceColor',color);
		%hbar = bar(1:size(VS,2),VS(t,:),'EdgeColor','none','FaceColor',color,'BarWidth',w);
		hbar = bar([1:size(VS,2)]+shift,VS(t,:),'EdgeColor','none','FaceColor',color,'BarWidth',w);
		clist = [clist color(:)];
		ymax = max(ymax,max(VS(t,:)));
	end
	v = m;
    for i=1:length(m)
        if ~isnan(v(i));
            plot([i+shift-w/2 i+shift+w/2], [v(i) v(i)],'r-','LineWidth',2);
        end
	end
	%
	% 	v = max(VS)/maxelim*100;
	% 	for i=1:length(m)
	% 		plot([i-w/2 i+w/2], [v(i) v(i)],'k:','LineWidth',1);
	% 	end
	%baseline_handle = get(bar_handle,'BaseLine');
	%set(baseline_handle,'LineStyle','--','Color','red');
	%
	nm = size(V,2); %length(methods);
    pos = get(gca,'Position');
    set(gca,'Position',[pos(1), .2, pos(3) .65])
    Xt = 1:nm;
    Xl = [0.1 nm+0.9];
    set(gca,'XTick',Xt,'XLim',Xl);
    ax = axis;
    axis(axis);
    Yl = ax(3:4);
    %set(gca,'XTickLabel',methods);
    % Place the text labels
    % Remove the default labels
    set(gca,'XTickLabel','');
end

ylim([0 ymax]);

%% text labels

t = text(Xt,Yl(1)*ones(1,length(Xt)),Legent);
set(t,'HorizontalAlignment','right','VerticalAlignment','top', 'Rotation',45);
% Remove the default labels
if (l1(2)>0)
	h = legend('95%','70%','50%','mean');
	%rect = [0.16, ltop+0.05, .15, .20];
	rect = [l1(1), l1(2), .15, .20];
	set(h, 'Position', rect);
end

set(gca,'XTickLabel','')
ylabel('solution completeness, %');
%ylabel('time, sec');
box off;
drawnow;

%% additional legend box

xl = xlim;
yl = ylim;
axes;
hold on;
leg = {};
for gi=1:length(group)
	bh = bar(0,0,'EdgeColor','none','FaceColor',colors(gi,:),'BarWidth',0);
	lh = get(bh,'BaseLine');
	delete(lh);
	leg{end+1} = legg{gi}; %['K=' num2str(KK(gi))];
	%set(lh,'LineStyle','--','Color','red');
end
xlim(xl);
ylim(yl);
h = legend(leg);
rect = [l2(1), l2(2), .15, .05*ng];
set(h, 'Position', rect);
axis off;

h = title(tt);
set(h, 'Position', [4 91]);
set(h,'FontWeight','bold');

%% hatch colors for BW printing

h = gcf();
nb = length(group);
patterns = '/+\x|-wkc';
patterns = char(kron(patterns(1:nb),[1 1 1]));
im_hatch = applyhatch_pluscolor(h,patterns,1,1,clist',300,4,2);
mask1 = ~all(all(im_hatch==255,3),2);
mask2 = ~all(all(im_hatch==255,3),1);
x1(1) = find(mask1,1,'first');
x1(2) = find(mask1,1,'last');
x2(1) = find(mask2,1,'first');
x2(2) = find(mask2,1,'last');
im_hatch = im_hatch(x1(1):x1(2),x2(1):x2(2),:);
imwrite(im_hatch,[pth out '-hatch.png']);
%clf;
%imshow(im_hatch);
%pdffig([pth out '-hatch']);

%figure(4);clf;
%imagesc(im_hatch);