function E = hpo_gen_grid3_KS(N,M,T)

nV = N*M;
maxd = 3;
H = hyper_graph1(nV,maxd);
E = hyper_energy1(H);
E.fA(:) = 0;
% copy offsets from the original code
si = [-1,0,0;
	+1,0,0;
	-1,0,0;
	+1,0,0;
	-1,0,-1;
	-1,0,+1;
	0,0,0;
	0,0,0];
sj = [0,0,+1;
	0,0,+1;
	0,0,-1;
	0,0,-1;
	0,0,0;
	0,0,0;
	-1,0,-1;
	-1,0,+1];

for t=1:T % generate T triples per pixel (if they fit in the grid)
	d = [si(t,:); sj(t,:)];
	for i=1:N
		for j=1:M
			x = d+repmat([i;j],1,3);
			if all(all(x >= 1)) && all(all(x<=repmat([N;M],1,3))) % clique fits
				v = sub2ind([N M],x(1,:),x(2,:));
				[H a] = H.add_edge(v);
				% generate random polynomial over the clique
				bb = row(H.A(H.A(:,a)>0,a)); % get subsets
				% sample random coefficients
				coeffs = randi(201,2^maxd,1)-100; % random coeffs in [-100 100];
				if size(E.fA,2)<size(H.A,2)
					E.fA(:,size(H.A,2)) = 0;
				end
				for l = 2:length(bb)
					b = bb(l);
					bd = H.d(b);
					z = 2^bd-1;
					E.fA(z+1,b) = E.fA(z+1,b)+coeffs(l);
				end
			end
		end
	end
end

E.H = H;
end