function E = hpo_gen_poly_KS(nV,d,T,it)
% random polynomials of Kahl and Strandmark
% don't reproduce generation procedure, just read what they generated
I = {};
E = {};
pth = ['KS-poly/' num2str(d) '/' num2str(nV) '-' num2str(T) '/'];
ff = dir([pth '*.txt']);
if it>length(ff)
	it = randi(length(ff));
end
f = fopen([pth ff(it).name]);
s = fgetl(f);
v = sscanf(s, '%f');
nV = v(1); % number of variables
I{1} = 1:nV;
C{1} = v(2:end); % reminder of v is unary coeffs
maxd = 0;
nA = nV+1;
for d = 2:5
	if feof(f)
		maxd = d-1;
		break;
	end
	s = fgetl(f);
	v = sscanf(s, '%f');
	n = v(1); %number of touples
	nA = nA + n;
	v(1) = [];
	if n==0
		I{d} = [];
		C{d} = [];
		maxd = d-1;
		break;
	end
	v = reshape(v,[],n);
	I{d} = v(1:d,:);
	C{d} = v(d+1:end,:);
end
fclose(f);
H = hyper_graph1(nV,maxd);
E = hyper_energy1(H);
E.fA = sparse(2^maxd,nA,nA);
E.fA(:) = 0;
for d=1:maxd
	for i = 1:size(I{d},2)
		[H a] = H.add_edge(I{d}(:,i)');
		if a>size(E.fA,2)
			E.fA(:,a) = 0;
		end
		E.fA(2^d,a) = C{d}(i);
	end
end
E.H = H;
return

% up to a random generator used
H = hyper_graph1(nV,d);
E = hyper_energy1(H);
E.fA(:) = 0;
% KS first generates sequentially to cover all nodes
V = [];
for i=1:d:nV-d
	v = i:i+d-1;
	V = [V;v];
	T = T-1;
end
i = nV-d+1;
v = i:i+d-1;
V = [V;v];
T = T-1;
for t=1:T % now remaining random touples
	v = randperm(nV); v = v(1:d); % select d variables randomly
	V = [V;v];
end
for t=1:size(V,1);
	v = V(t,:);
	[H a] = H.add_edge(v);
	% all configs = all subsets, so can just assign the higher order term randomly
	% how many coeffs: 2^d
	coeffs = randi(201,2^d,1)-100; % random coeffs in [-100 100];
	% KS does not generate constant coeff
	coeffs(1) = 0;
	E.fA(1:2^d,a) = coeffs;
end
E.H = H;
end