function [p time] = hpo_grd(F,y,method)
nV = get_nV(F);
nA = get_nA(F);
H = F.H;

F = F.to_multilinear(); % just to avoid confusion of enumerating values (reordering below has no effect)

E ={};
I = {};
for d=1:4
	E{d} = [];
	I{d} = [];
end
for d = 1:H.maxd
	v = find(H.sub(:,2),d,'first');% node indices
	I{d} = uint32(full(H.A(v,H.d==d)-1));
	E{d} = full(F.fA(1:2^d,H.d==d));% energy values
	% for GRD each column should be [E000; E001; .... E111]
	% but here first var is the smallest bit,so reorder
	z = [0:2^d-1]';
	x = dec2bin(z,d);
	x = fliplr(x);
	z1 = bin2dec(x);
	E{d} = E{d}(z1+1,:);
end

% 'method'	:	{'GRD','GRD-gen','GRD-heur','Fix','HOCR'}
home = pwd;
pth = file_path(which('grd_mex'));
cd([pth '/../bin/']);
try
	tic;
	[L energy] = grd(E{1},I{2},E{2},I{3},E{3},I{4},E{4},'method',method);
	time = toc;
catch
end
cd(home);

L = row(L);
p = repmat(L,2,1);
p(1,L==-1) = 0;
p(2,L==-1) = 1;

end