function [p time] = hpo_iterative(F,y,LP)
nV = get_nV(F);
nA = get_nA(F);
H = F.H;
I = H.A;
nI = nnz(I);
I(I>0) = 1:nI;

if(~exist('y','var') || isempty(y))
	[y LB mu1 Mu] = F.full_LP(false,LP);
end

p = repmat(y,2,1); % all to y

G = F;
f = F.fA(F.H.A>0);

time = 0;

while true
% verification LP
P = F.extend_map(p);
g = f-P'*f;
G.fA(F.H.A>0) = g;

[x LB mu1 Mu ans ans dt] = G.full_LP(false,LP);
time = time+dt;
fprintf('verification LP: %f\n',LB);
if LB>-1e-5 % current map is optimal
	return;
end
% remove some labels from the map
for v=1:nV
	if mu1(y(v)+1,v) < 1-1e-5 % optimal solution selects something else that y
		p(:,v) = [0;1]; % immovable
	end
end

end

end