function [ilp_time rilp_time] = hpo_verify(F,p,LP)
G = F;
nV = get_nV(F);

f = F.fA(F.H.A>0);
P = F.extend_map(p);
g = f-P'*f;
G.fA(F.H.A>0) = g;
[x LB mu1 Mu] = G.full_LP(false,LP);
if LB>-1e-5 % map is improving
	fprintf('%s-improving\n',LP);
else
	fprintf('not %s-improving, value % f\n',LP,LB);
	error('theory or the implementation fails');
end

if 1 %nV<100
	[xi LBi ans ans ans ans t1] = F.full_LP(true,LP); % full ILP
	% % verify with constrained minimization, must not break optimal solution
	%{
	for v=1:nV
		if p(1,v)==p(2,v)
			x = ~p(1,v);
			F.fA(x+1,v+1) = 1e6; % forbid this assignment
		end
	end
	%}
	%[x LB mu1 Mu ans ans t2] = F.full_LP(true,LP); % simplified LP
	%mask = p(1,:)==p(2,:);
	[F1 pi] = F.restrict(p);
	[x LB ans ans ans ans t2] = F1.full_LP(true,LP); % simplified ILP
	%assert(abs(LB-LBi)<1e-5); % solution of the same cost
	%x2 = zeros(1,nV);
	%x2(mask) = p(1,mask);
	%x2(~mask) = x;
	if abs(LB-LBi)<1e-5
		fprintf('PO verified\n');
	else
		error('PO failed');
	end
	fprintf('simplified speedup: simplified %3.2fs/ full %3.2fs\n',t2,t1);
	ilp_time  = t1;
	rilp_time = t2;
end
end