function [Mu MuA] = hpo_verify_strict(F,p,LP)
% check whether p is a strictly relaxed-improving
G = F;
nV = get_nV(F);
eps = 0.01;
hA = F.fA;
nA = F.H.get_nA();
for a = 1:nA
	vv = F.H.get_nodes(a);
	d = length(vv);
	for z=0:2^d-1
		x = mdec2bin(z,d);
		y = mselect(p(:,vv),x+1,1:d);
		hA(z+1,a) = any(x~=y);
	end
end
h = hA(F.H.A>0);
f = F.fA(F.H.A>0);
P = F.extend_map(p);
g = f-P'*f-eps*h;
G.fA(F.H.A>0) = g;
[x LB mu1 Mu] = G.full_LP(false,LP);
if LB>-1e-5 % map is improving
	fprintf('strictly %s-improving\n',LP);
else
	fprintf('not strictly %s-improving, value % f\n',LP,LB);
	%error('theory or the implementation fails');
	MuA = F.fA;
	MuA(F.H.A>0) = Mu;
end
end